﻿// (c) 2013 Cesys GmbH
// Author: Thomas Hoppe
using System;
using System.Collections.Generic;
using System.Text;

namespace CeboMsrNet
{
    /// <summary>
    /// Values to be used in enumeration.
    /// </summary>
    public sealed class DeviceType
    {
        private uint _interfaceId;
        private string _name;

        private DeviceType(uint interfaceId, string name)
        {
            _interfaceId = interfaceId;
            _name = name;
        }

        internal uint InterfaceId { get { return _interfaceId; } }

        internal static DeviceType GetDeviceTypeById(uint id)
        {
            switch (id)
            {
                case SystemConnector.CeboMsrTypeAll: return All;
                case SystemConnector.CeboMsrTypeUsb: return Usb;
                case SystemConnector.CeboMsrTypeCeboLC: return CeboLC;
                case SystemConnector.CeboMsrTypeCeboStick: return CeboStick;
            }
            throw new IndexOutOfRangeException();
        }

        public static readonly DeviceType All = new DeviceType(SystemConnector.CeboMsrTypeAll, "All");
        public static readonly DeviceType Usb = new DeviceType(SystemConnector.CeboMsrTypeUsb, "Usb");
        public static readonly DeviceType CeboLC = new DeviceType(SystemConnector.CeboMsrTypeCeboLC, "CeboLC");
        public static readonly DeviceType CeboStick = new DeviceType(SystemConnector.CeboMsrTypeCeboStick, "CeboStick");

        /// <summary>
        /// Return instance name, "Usb", "All", ...
        /// </summary>
        public string Name { get { return _name; } }
    }
}
